Linux srv.fwservers.com 4.18.0-477.21.1.el8_8.x86_64 #1 SMP Thu Aug 10 13:51:50 EDT 2023 x86_64
Apache
Server IP : 199.127.63.82 & Your IP : 216.73.216.63
Domains : 56 Domain
User : aconstruction
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
sbin /
Delete
Unzip
Name
Size
Permission
Date
Action
NetworkManager
3.41
MB
-rwxr-xr-x
2026-08-24 06:01
accessdb
12.59
KB
-rwxr-xr-x
2021-10-08 13:04
accton
13.69
KB
-rwxr-xr-x
2019-10-21 16:09
adcli
179.27
KB
-rwxr-xr-x
2023-03-31 18:37
addgnupghome
3
KB
-rwxr-xr-x
2018-12-11 07:44
addpart
24.86
KB
-rwxr-xr-x
2026-02-04 20:18
adduser
148.16
KB
-rwxr-xr-x
2025-12-18 13:51
agetty
62.39
KB
-rwxr-xr-x
2026-02-04 20:18
alternatives
36.66
KB
-rwxr-xr-x
2023-10-14 22:48
anacron
40.99
KB
-rwxr-xr-x
2024-04-06 11:40
apachectl
4.69
KB
-rwxr-xr-x
2026-08-11 22:29
applygnupgdefaults
2.17
KB
-rwxr-xr-x
2017-12-18 12:28
arp
64.71
KB
-rwxr-xr-x
2020-08-30 17:47
arpd
109.52
KB
-rwxr-xr-x
2024-05-23 08:36
arping
28.74
KB
-rwxr-xr-x
2023-10-14 17:19
atd
32.63
KB
-rwxr-xr-x
2022-10-10 10:23
atrun
67
B
-rwxr-xr-x
2022-10-10 10:23
auditctl
45.04
KB
-rwxr-xr-x
2025-07-15 09:41
auditd
151.73
KB
-rwxr-xr-x
2025-07-15 09:41
augenrules
4.04
KB
-rwxr-xr-x
2025-07-15 09:41
aureport
122.35
KB
-rwxr-xr-x
2025-07-15 09:41
ausearch
130.36
KB
-rwxr-xr-x
2025-07-15 09:41
autrace
16.54
KB
-rwxr-x---
2025-07-15 09:41
avcstat
16.4
KB
-rwxr-xr-x
2026-02-10 14:26
badblocks
32.59
KB
-rwxr-xr-x
2025-10-07 07:08
biosdecode
21.45
KB
-rwxr-xr-x
2024-04-06 13:04
biosdevname
46.16
KB
-rwxr-xr-x
2019-10-18 20:07
blkdeactivate
15.97
KB
-r-xr-xr-x
2026-01-23 07:31
blkdiscard
29.05
KB
-rwxr-xr-x
2026-02-04 20:18
blkid
98.66
KB
-rwxr-xr-x
2026-02-04 20:18
blkmapd
53.47
KB
-rwxr-xr-x
2026-07-08 15:02
blkzone
49.75
KB
-rwxr-xr-x
2026-02-04 20:18
blockdev
41.3
KB
-rwxr-xr-x
2026-02-04 20:18
bpftool
2.74
MB
-rwxr-xr-x
2026-08-26 07:56
bridge
158.25
KB
-rwxr-xr-x
2024-05-23 08:36
build-locale-archive
841.06
KB
-rwx------
2026-07-21 14:52
cache_check
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
cache_dump
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
cache_metadata_size
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
cache_repair
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
cache_restore
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
cache_writeback
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
capsh
32.45
KB
-rwxr-xr-x
2026-05-04 20:33
cfdisk
98.41
KB
-rwxr-xr-x
2026-02-04 20:18
chcpu
28.83
KB
-rwxr-xr-x
2026-02-04 20:18
chgpasswd
69.69
KB
-rwxr-xr-x
2025-12-18 13:51
chkconfig
45.11
KB
-rwxr-xr-x
2023-10-14 22:48
chpasswd
61.42
KB
-rwxr-xr-x
2025-12-18 13:51
chronyd
375.66
KB
-rwxr-xr-x
2024-11-05 07:47
chroot
41.45
KB
-rwxr-xr-x
2026-07-28 19:49
clock
65.22
KB
-rwxr-xr-x
2026-02-04 20:18
clockdiff
20.43
KB
-rwxr-xr-x
2023-10-14 17:19
consoletype
11.86
KB
-rwxr-xr-x
2025-11-04 09:19
convertquota
78.68
KB
-rwxr-xr-x
2021-10-09 07:08
cracklib-check
13.05
KB
-rwxr-xr-x
2019-10-12 00:47
cracklib-format
251
B
-rwxr-xr-x
2019-10-12 00:47
cracklib-packer
13.05
KB
-rwxr-xr-x
2019-10-12 00:47
cracklib-unpacker
9.03
KB
-rwxr-xr-x
2019-10-12 00:47
create-cracklib-dict
990
B
-rwxr-xr-x
2019-10-12 00:47
crond
73.94
KB
-rwxr-xr-x
2024-04-06 11:40
cryptsetup
147.42
KB
-rwxr-xr-x
2023-10-15 03:50
ctrlaltdel
24.79
KB
-rwxr-xr-x
2026-02-04 20:18
ctstat
25.33
KB
-rwxr-xr-x
2024-05-23 08:36
dcb
155.04
KB
-rwxr-xr-x
2024-05-23 08:36
ddns-confgen
20.46
KB
-rwxr-xr-x
2026-08-13 18:53
debugfs
231.63
KB
-rwxr-xr-x
2025-10-07 07:08
delpart
24.86
KB
-rwxr-xr-x
2026-02-04 20:18
depmod
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
devlink
215.87
KB
-rwxr-xr-x
2024-05-23 08:36
dmeventd
45.08
KB
-r-xr-xr-x
2026-01-23 07:31
dmfilemapd
24.55
KB
-r-xr-xr-x
2026-01-23 07:31
dmidecode
141.8
KB
-rwxr-xr-x
2024-04-06 13:04
dmsetup
158.64
KB
-r-xr-xr-x
2026-01-23 07:31
dmstats
158.64
KB
-r-xr-xr-x
2026-01-23 07:31
dnssec-checkds
936
B
-rwxr-xr-x
2026-08-13 18:52
dnssec-coverage
938
B
-rwxr-xr-x
2026-08-13 18:52
dnssec-dsfromkey
60.84
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-importkey
60.84
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-keyfromlabel
64.76
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-keygen
72.84
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-keymgr
934
B
-rwxr-xr-x
2026-08-13 18:52
dnssec-revoke
56.74
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-settime
60.84
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-signzone
117.2
KB
-rwxr-xr-x
2026-08-13 18:53
dnssec-verify
52.84
KB
-rwxr-xr-x
2026-08-13 18:53
dosfsck
65.13
KB
-rwxr-xr-x
2019-10-12 00:48
dosfslabel
61.1
KB
-rwxr-xr-x
2019-10-12 00:48
dovecot
162.18
KB
-rwxr-xr-x
2026-07-15 21:51
dovecot_cpshutdown
3.27
KB
-rwxr-xr-x
2026-07-13 00:00
dpkg-fsys-usrunmess
12.11
KB
-rwxr-xr-x
2021-12-15 12:46
dump-acct
29.15
KB
-rwxr-xr-x
2019-10-21 16:09
dump-utmp
25.02
KB
-rwxr-xr-x
2019-10-21 16:09
dumpe2fs
32.52
KB
-rwxr-xr-x
2025-10-07 07:08
e2freefrag
16.42
KB
-rwxr-xr-x
2025-10-07 07:08
e2fsck
328.52
KB
-rwxr-xr-x
2025-10-07 07:08
e2image
36.61
KB
-rwxr-xr-x
2025-10-07 07:08
e2label
110.63
KB
-rwxr-xr-x
2025-10-07 07:08
e2mmpstatus
32.52
KB
-rwxr-xr-x
2025-10-07 07:08
e2undo
20.38
KB
-rwxr-xr-x
2025-10-07 07:08
e4crypt
24.55
KB
-rwxr-xr-x
2025-10-07 07:08
e4defrag
28.49
KB
-rwxr-xr-x
2025-10-07 07:08
ebtables
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ebtables-restore
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ebtables-save
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
edquota
91.24
KB
-rwxr-xr-x
2021-10-09 07:08
era_check
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
era_dump
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
era_invalidate
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
era_restore
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
ether-wake
73.99
KB
-rwxr-xr-x
2020-08-30 17:47
ethtool
557.79
KB
-rwxr-xr-x
2022-10-08 17:27
exicyclog
11.1
KB
-rwxr-xr-x
2026-07-24 13:17
exigrep
11.44
KB
-rwxr-xr-x
2026-07-24 13:17
exim
1.53
MB
-rwsr-xr-x
2026-07-24 13:17
exim_checkaccess
4.83
KB
-rwxr-xr-x
2026-07-24 13:17
exim_dbmbuild
24.69
KB
-rwxr-xr-x
2026-07-24 13:17
exim_dumpdb
43.56
KB
-rwxr-xr-x
2026-07-24 13:17
exim_fixdb
49.05
KB
-rwxr-xr-x
2026-07-24 13:17
exim_lock
26.59
KB
-rwxr-xr-x
2026-07-24 13:17
exim_tidydb
43.78
KB
-rwxr-xr-x
2026-07-24 13:17
eximstats
149.14
KB
-rwxr-xr-x
2026-07-24 13:17
exinext
8.03
KB
-rwxr-xr-x
2026-07-24 13:17
exiqgrep
6.58
KB
-rwxr-xr-x
2026-07-24 13:17
exiqsumm
6.29
KB
-rwxr-xr-x
2026-07-24 13:17
exiwhat
4.42
KB
-rwxr-xr-x
2026-07-24 13:17
exportfs
82.38
KB
-rwxr-xr-x
2026-07-08 15:02
faillock
20.52
KB
-rwxr-xr-x
2026-08-18 13:12
fatlabel
61.1
KB
-rwxr-xr-x
2019-10-12 00:48
fcgistarter
17.11
KB
-rwxr-xr-x
2026-08-11 22:33
fdformat
33.17
KB
-rwxr-xr-x
2026-02-04 20:18
fdisk
130.91
KB
-rwxr-xr-x
2026-02-04 20:18
filefrag
16.46
KB
-rwxr-xr-x
2025-10-07 07:08
findfs
12.38
KB
-rwxr-xr-x
2026-02-04 20:18
firewalld
6.92
KB
-rwxr-xr-x
2026-08-18 13:10
fix-info-dir
7.84
KB
-rwxr-xr-x
2022-04-18 17:09
fixfiles
10.48
KB
-rwxr-xr-x
2024-07-02 21:04
fsadm
24
KB
-r-xr-xr-x
2026-01-23 07:31
fsck
53.47
KB
-rwxr-xr-x
2026-02-04 20:18
fsck.cramfs
41.41
KB
-rwxr-xr-x
2026-02-04 20:18
fsck.ext2
328.52
KB
-rwxr-xr-x
2025-10-07 07:08
fsck.ext3
328.52
KB
-rwxr-xr-x
2025-10-07 07:08
fsck.ext4
328.52
KB
-rwxr-xr-x
2025-10-07 07:08
fsck.fat
65.13
KB
-rwxr-xr-x
2019-10-12 00:48
fsck.minix
98.75
KB
-rwxr-xr-x
2026-02-04 20:18
fsck.msdos
65.13
KB
-rwxr-xr-x
2019-10-12 00:48
fsck.vfat
65.13
KB
-rwxr-xr-x
2019-10-12 00:48
fsck.xfs
1.92
KB
-rwxr-xr-x
2023-10-15 05:10
fsfreeze
16.38
KB
-rwxr-xr-x
2026-02-04 20:18
fstrim
49.6
KB
-rwxr-xr-x
2026-02-04 20:18
fuse2fs
70.39
KB
-rwxr-xr-x
2025-10-07 07:08
fuser
38.14
KB
-rwxr-xr-x
2020-11-06 14:24
g13-syshelp
189.76
KB
-rwxr-xr-x
2026-01-16 01:48
genhomedircon
29.27
KB
-rwxr-xr-x
2024-07-02 21:04
genhostid
11.86
KB
-rwxr-xr-x
2025-11-04 09:19
genl
121.41
KB
-rwxr-xr-x
2024-05-23 08:36
genrandom
12.38
KB
-rwxr-xr-x
2026-08-13 18:53
getcap
12.35
KB
-rwxr-xr-x
2026-05-04 20:33
getenforce
7.84
KB
-rwxr-xr-x
2026-02-10 14:26
getpcaps
12.27
KB
-rwxr-xr-x
2026-05-04 20:33
getsebool
11.87
KB
-rwxr-xr-x
2026-02-10 14:26
groupadd
95.34
KB
-rwxr-xr-x
2025-12-18 13:51
groupdel
91.09
KB
-rwxr-xr-x
2025-12-18 13:51
groupmems
61.48
KB
-rwxr-xr-x
2025-12-18 13:51
groupmod
99.38
KB
-rwxr-xr-x
2025-12-18 13:51
grpck
61.47
KB
-rwxr-xr-x
2025-12-18 13:51
grpconv
57.27
KB
-rwxr-xr-x
2025-12-18 13:51
grpunconv
57.26
KB
-rwxr-xr-x
2025-12-18 13:51
grub2-bios-setup
1.16
MB
-rwxr-xr-x
2026-08-03 03:56
grub2-get-kernel-settings
2.68
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-install
1.44
MB
-rwxr-xr-x
2026-08-03 03:56
grub2-macbless
1.14
MB
-rwxr-xr-x
2026-08-03 03:56
grub2-mkconfig
8.68
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-ofpathname
246.31
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-probe
1.16
MB
-rwxr-xr-x
2026-08-03 03:56
grub2-reboot
3.99
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-rpm-sort
283.14
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-set-bootflag
16.35
KB
-rwsr-xr-x
2026-08-03 03:56
grub2-set-default
3.45
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-set-password
3.05
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-setpassword
3.05
KB
-rwxr-xr-x
2026-08-03 03:56
grub2-sparc64-setup
1.16
MB
-rwxr-xr-x
2026-08-03 03:56
grub2-switch-to-blscfg
8.6
KB
-rwxr-xr-x
2026-08-03 03:56
grubby
260
B
-rwxr-xr-x
2026-07-28 19:53
gss-server
24.61
KB
-rwxr-xr-x
2026-05-13 06:34
gssproxy
132.08
KB
-rwxr-xr-x
2022-10-08 08:02
halt
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
hardlink
17.09
KB
-rwxr-xr-x
2019-10-15 21:49
hdparm
131.91
KB
-rwxr-xr-x
2021-10-08 19:47
htcacheclean
44.36
KB
-rwxr-xr-x
2026-08-11 22:33
httpd
991.46
KB
-rwxr-xr-x
2026-08-11 22:33
hwclock
65.22
KB
-rwxr-xr-x
2026-02-04 20:18
iconvconfig
33.05
KB
-rwxr-xr-x
2026-07-21 14:52
ifconfig
80.86
KB
-rwxr-xr-x
2020-08-30 17:47
ifdown
2.07
KB
-rwxr-xr-x
2025-09-23 08:27
ifenslave
24.95
KB
-rwxr-xr-x
2023-10-14 17:19
ifstat
117.67
KB
-rwxr-xr-x
2024-05-23 08:36
ifup
5.33
KB
-rwxr-xr-x
2025-09-23 08:27
imunify-notifier
9.82
MB
-rwxr-xr-x
2026-07-07 08:52
init
1.54
MB
-rwxr-xr-x
2026-06-16 17:17
insmod
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
install-info
50.23
KB
-rwxr-xr-x
2022-04-18 17:09
installkernel
323
B
-rwxr-xr-x
2026-07-28 19:53
intel_sdsi
15.62
KB
-rwxr-xr-x
2026-08-26 07:56
ip
693.3
KB
-rwxr-xr-x
2024-05-23 08:36
ip6tables
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ip6tables-apply
6.89
KB
-rwxr-xr-x
2024-04-02 18:37
ip6tables-restore
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ip6tables-restore-translate
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ip6tables-save
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ip6tables-translate
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
ipmaddr
21
KB
-rwxr-xr-x
2020-08-30 17:47
iprconfig
408.03
KB
-rwxr-xr-x
2020-08-30 07:37
iprdbg
137.57
KB
-rwxr-xr-x
2020-08-30 07:37
iprdump
129.3
KB
-rwxr-xr-x
2020-08-30 07:37
iprinit
125.28
KB
-rwxr-xr-x
2020-08-30 07:37
iprsos
2.18
KB
-rwxr-xr-x
2020-05-08 14:19
iprupdate
129.3
KB
-rwxr-xr-x
2020-08-30 07:37
ipset
9.01
KB
-rwxr-xr-x
2019-11-12 14:33
iptables
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
iptables-apply
6.89
KB
-rwxr-xr-x
2024-04-02 18:37
iptables-restore
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
iptables-restore-translate
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
iptables-save
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
iptables-translate
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
iptstate
92.05
KB
-rwxr-xr-x
2019-10-15 21:54
iptunnel
25
KB
-rwxr-xr-x
2020-08-30 17:47
irqbalance
62.28
KB
-rwxr-xr-x
2023-10-14 17:57
irqbalance-ui
41.29
KB
-rwxr-xr-x
2023-10-14 17:57
isc-hmac-fixup
11.86
KB
-rwxr-xr-x
2026-08-13 18:53
kexec
194.98
KB
-rwxr-xr-x
2026-02-10 17:24
key.dns_resolver
24.52
KB
-rwxr-xr-x
2021-10-08 13:50
kpartx
49.05
KB
-rwxr-xr-x
2026-05-05 11:28
kpatch
16.59
KB
-rwxr-xr-x
2025-07-15 11:39
lchage
16.41
KB
-rwxr-xr-x
2024-09-24 02:24
ldattach
32.99
KB
-rwxr-xr-x
2026-02-04 20:18
ldconfig
986.1
KB
-rwxr-xr-x
2026-07-21 14:52
ledctl
101.16
KB
-rwxr-xr-x
2023-10-14 22:53
ledmon
101.11
KB
-rwxr-xr-x
2023-10-14 22:53
lgroupadd
11.88
KB
-rwxr-xr-x
2024-09-24 02:24
lgroupdel
11.88
KB
-rwxr-xr-x
2024-09-24 02:24
lgroupmod
19.88
KB
-rwxr-xr-x
2024-09-24 02:24
lid
16.27
KB
-rwxr-xr-x
2024-09-24 02:24
lnewusers
19.87
KB
-rwxr-xr-x
2024-09-24 02:24
lnstat
25.33
KB
-rwxr-xr-x
2024-05-23 08:36
load_policy
12.28
KB
-rwxr-xr-x
2024-07-02 21:04
logrotate
93.03
KB
-rwxr-xr-x
2023-04-02 00:29
logsave
16.41
KB
-rwxr-xr-x
2025-10-07 07:08
losetup
90.59
KB
-rwxr-xr-x
2026-02-04 20:18
lpasswd
20.35
KB
-rwxr-xr-x
2024-09-24 02:24
lshw
969.55
KB
-rwxr-xr-x
2025-10-07 08:50
lsmod
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
lspci
94.85
KB
-rwxr-xr-x
2023-03-31 21:30
luseradd
19.88
KB
-rwxr-xr-x
2024-09-24 02:24
luserdel
15.88
KB
-rwxr-xr-x
2024-09-24 02:24
lusermod
19.88
KB
-rwxr-xr-x
2024-09-24 02:24
lvchange
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvconvert
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvcreate
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvdisplay
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvextend
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvm
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvm_import_vdo
23.14
KB
-r-xr-xr-x
2026-01-23 07:31
lvmconfig
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvmdevices
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvmdiskscan
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvmdump
10.12
KB
-r-xr-xr-x
2026-01-23 07:31
lvmpolld
200.7
KB
-r-xr-xr-x
2026-01-23 07:31
lvmsadc
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvmsar
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvreduce
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvremove
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvrename
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvresize
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvs
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lvscan
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
lwresd
840.94
KB
-rwxr-xr-x
2026-08-13 18:53
makedumpfile
425.19
KB
-rwxr-xr-x
2026-02-10 17:24
matchpathcon
12.37
KB
-rwxr-xr-x
2026-02-10 14:26
mcelog
206.3
KB
-rwxr-xr-x
2024-04-06 12:45
mdadm
620.75
KB
-rwxr-xr-x
2025-11-05 10:54
mdmon
379.51
KB
-rwxr-xr-x
2025-11-05 10:54
mii-diag
25.4
KB
-rwxr-xr-x
2020-08-30 17:47
mii-tool
21.03
KB
-rwxr-xr-x
2020-08-30 17:47
mkdict
251
B
-rwxr-xr-x
2019-10-12 00:47
mkdosfs
39.07
KB
-rwxr-xr-x
2019-10-12 00:48
mkdumprd
12.68
KB
-rwxr-xr-x
2026-02-10 17:24
mke2fs
138.45
KB
-rwxr-xr-x
2025-10-07 07:08
mkfadumprd
2.23
KB
-rwxr-xr-x
2026-02-10 17:24
mkfs
16.48
KB
-rwxr-xr-x
2026-02-04 20:18
mkfs.cramfs
41.27
KB
-rwxr-xr-x
2026-02-04 20:18
mkfs.ext2
138.45
KB
-rwxr-xr-x
2025-10-07 07:08
mkfs.ext3
138.45
KB
-rwxr-xr-x
2025-10-07 07:08
mkfs.ext4
138.45
KB
-rwxr-xr-x
2025-10-07 07:08
mkfs.fat
39.07
KB
-rwxr-xr-x
2019-10-12 00:48
mkfs.minix
86.56
KB
-rwxr-xr-x
2026-02-04 20:18
mkfs.msdos
39.07
KB
-rwxr-xr-x
2019-10-12 00:48
mkfs.vfat
39.07
KB
-rwxr-xr-x
2019-10-12 00:48
mkfs.xfs
475.98
KB
-rwxr-xr-x
2023-10-15 05:11
mkhomedir_helper
24.44
KB
-rwxr-xr-x
2026-08-18 13:12
mklost+found
11.86
KB
-rwxr-xr-x
2025-10-07 07:08
mksquashfs
186.83
KB
-rwxr-xr-x
2024-04-06 14:17
mkswap
86.48
KB
-rwxr-xr-x
2026-02-04 20:18
modinfo
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
modprobe
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
modsec-sdbm-util
25.83
KB
-rwxr-x---
2026-08-11 22:29
mount.nfs
197.24
KB
-rwsr-xr-x
2026-07-08 15:02
mount.nfs4
197.24
KB
-rwsr-xr-x
2026-07-08 15:02
mountstats
42.22
KB
-rwxr-xr-x
2026-07-08 15:02
mtr
110.92
KB
-rwxr-xr-x
2019-12-15 02:52
mtr-packet
58.3
KB
-rwxr-xr-x
2019-12-15 02:52
mysqld
63.03
MB
-rwxr-xr-x
2026-04-07 17:09
named
840.94
KB
-rwxr-xr-x
2026-08-13 18:53
named-checkconf
40.79
KB
-rwxr-xr-x
2026-08-13 18:53
named-checkzone
36.63
KB
-rwxr-xr-x
2026-08-13 18:53
named-compilezone
36.63
KB
-rwxr-xr-x
2026-08-13 18:53
named-journalprint
11.85
KB
-rwxr-xr-x
2026-08-13 18:53
nameif
16.98
KB
-rwxr-xr-x
2020-08-30 17:47
newusers
107.23
KB
-rwxr-xr-x
2025-12-18 13:51
nfsconf
37.48
KB
-rwxr-xr-x
2026-07-08 15:02
nfsconvert
13.03
KB
-rwxr-xr-x
2026-07-08 15:02
nfsdcld
65.87
KB
-rwxr-xr-x
2026-07-08 15:02
nfsdclddb
10
KB
-rwxr-xr-x
2026-07-08 15:02
nfsdclnts
9.02
KB
-rwxr-xr-x
2026-07-08 15:02
nfsdcltrack
49.78
KB
-rwxr-xr-x
2026-07-08 15:02
nfsidmap
45.36
KB
-rwxr-xr-x
2026-07-08 15:02
nfsiostat
23.36
KB
-rwxr-xr-x
2026-07-08 15:02
nfsref
65.8
KB
-rwxr-xr-x
2026-07-08 15:02
nfsstat
35.52
KB
-rwxr-xr-x
2026-07-08 15:02
nft
24.41
KB
-rwxr-xr-x
2026-08-18 13:03
nginx
2.02
MB
-rwxr-xr-x
2026-08-26 01:21
nginx-debug
2.17
MB
-rwxr-xr-x
2026-08-26 01:21
nologin
11.87
KB
-rwxr-xr-x
2026-02-04 20:18
nscd
156.69
KB
-rwxr-xr-x
2026-07-21 14:52
nsec3hash
12.29
KB
-rwxr-xr-x
2026-08-13 18:53
nstat
113.57
KB
-rwxr-xr-x
2024-05-23 08:36
nvme
721.38
KB
-rwxr-xr-x
2026-04-14 18:44
ownership
12.4
KB
-rwxr-xr-x
2024-04-06 13:04
packer
13.05
KB
-rwxr-xr-x
2019-10-12 00:47
pam_console_apply
45.2
KB
-rwxr-xr-x
2026-08-18 13:12
pam_timestamp_check
11.87
KB
-rwsr-xr-x
2026-08-18 13:12
paperconfig
4.07
KB
-rwxr-xr-x
2019-10-12 20:09
parted
85.6
KB
-rwxr-xr-x
2021-10-08 15:43
partprobe
16.39
KB
-rwxr-xr-x
2021-10-08 15:43
partx
94.5
KB
-rwxr-xr-x
2026-02-04 20:18
pdata_tools
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
pdns_server
6.26
MB
-rwxr-xr-x
2026-08-10 19:13
pidof
16.7
KB
-rwxr-xr-x
2023-10-14 20:31
ping
66.13
KB
-rwxr-xr-x
2023-10-14 17:19
ping6
66.13
KB
-rwxr-xr-x
2023-10-14 17:19
pivot_root
12.38
KB
-rwxr-xr-x
2026-02-04 20:18
plipconfig
12.71
KB
-rwxr-xr-x
2020-08-30 17:47
pluginviewer
20.57
KB
-rwxr-xr-x
2022-02-23 20:13
poweroff
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
pvchange
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvck
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvcreate
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvdisplay
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvmove
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvremove
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvresize
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvs
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pvscan
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
pwck
57.27
KB
-rwxr-xr-x
2025-12-18 13:51
pwconv
53.1
KB
-rwxr-xr-x
2025-12-18 13:51
pwhistory_helper
20.43
KB
-rwxr-xr-x
2026-08-18 13:12
pwunconv
53.13
KB
-rwxr-xr-x
2025-12-18 13:51
quot
78.67
KB
-rwxr-xr-x
2021-10-09 07:08
quotacheck
115.75
KB
-rwxr-xr-x
2021-10-09 07:08
quotaoff
83.16
KB
-rwxr-xr-x
2021-10-09 07:08
quotaon
83.16
KB
-rwxr-xr-x
2021-10-09 07:08
quotastats
16.54
KB
-rwxr-xr-x
2021-10-09 07:08
raid-check
3.7
KB
-rwxr-xr-x
2025-11-05 07:57
rdisc
24.55
KB
-rwxr-xr-x
2023-10-14 17:19
rdma
187.38
KB
-rwxr-xr-x
2024-05-23 08:36
readprofile
20.55
KB
-rwxr-xr-x
2026-02-04 20:18
realm
144.26
KB
-rwxr-xr-x
2024-04-06 12:45
reboot
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
repquota
83.24
KB
-rwxr-xr-x
2021-10-09 07:08
request-key
24.38
KB
-rwxr-xr-x
2021-10-08 13:50
resize2fs
64.91
KB
-rwxr-xr-x
2025-10-07 07:08
resizepart
41.57
KB
-rwxr-xr-x
2026-02-04 20:18
resolvconf
195.75
KB
-rwxr-xr-x
2026-06-16 17:17
restorecon
20.53
KB
-rwxr-xr-x
2024-07-02 21:04
restorecon_xattr
16.41
KB
-rwxr-xr-x
2024-07-02 21:04
rfkill
53.46
KB
-rwxr-xr-x
2026-02-04 20:18
rmmod
159.95
KB
-rwxr-xr-x
2024-04-08 09:18
rndc
36.53
KB
-rwxr-xr-x
2026-08-13 18:53
rndc-confgen
20.45
KB
-rwxr-xr-x
2026-08-13 18:53
rotatelogs
30.51
KB
-rwxr-xr-x
2026-08-11 22:33
route
67.63
KB
-rwxr-xr-x
2020-08-30 17:47
rpc.gssd
106.54
KB
-rwxr-xr-x
2026-07-08 15:02
rpc.idmapd
61.73
KB
-rwxr-xr-x
2026-07-08 15:02
rpc.mountd
163.04
KB
-rwxr-xr-x
2026-07-08 15:02
rpc.nfsd
49.92
KB
-rwxr-xr-x
2026-07-08 15:02
rpc.statd
103.3
KB
-rwxr-xr-x
2026-07-08 15:02
rpcbind
61.55
KB
-rwxr-xr-x
2022-10-12 11:00
rpcctl
9.41
KB
-rwxr-xr-x
2026-07-08 15:02
rpcdebug
19.38
KB
-rwxr-xr-x
2026-07-08 15:02
rpcinfo
32.64
KB
-rwxr-xr-x
2022-10-12 11:00
rtacct
46.94
KB
-rwxr-xr-x
2024-05-23 08:36
rtcwake
49.3
KB
-rwxr-xr-x
2026-02-04 20:18
rtmon
117.27
KB
-rwxr-xr-x
2024-05-23 08:36
rtstat
25.33
KB
-rwxr-xr-x
2024-05-23 08:36
runlevel
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
runq
1.53
MB
-rwsr-xr-x
2026-07-24 13:17
runuser
48.99
KB
-rwxr-xr-x
2026-02-04 20:18
sa
46.62
KB
-rwxr-xr-x
2019-10-21 16:09
sasl2-shared-mechlist
12.19
KB
-rwxr-xr-x
2022-02-23 20:13
saslauthd
94.42
KB
-rwxr-xr-x
2022-02-23 20:13
sasldblistusers2
20.77
KB
-rwxr-xr-x
2022-02-23 20:13
saslpasswd2
16.42
KB
-rwxr-xr-x
2022-02-23 20:13
sedispatch
20.52
KB
-rwxr-xr-x
2024-04-06 13:44
sefcontext_compile
65.35
KB
-rwxr-xr-x
2026-02-10 14:26
selabel_digest
12.28
KB
-rwxr-xr-x
2026-02-10 14:26
selabel_lookup
12.27
KB
-rwxr-xr-x
2026-02-10 14:26
selabel_lookup_best_match
11.89
KB
-rwxr-xr-x
2026-02-10 14:26
selabel_partial_match
11.88
KB
-rwxr-xr-x
2026-02-10 14:26
selinux_check_access
12.36
KB
-rwxr-xr-x
2026-02-10 14:26
selinuxconlist
11.88
KB
-rwxr-xr-x
2026-02-10 14:26
selinuxdefcon
11.88
KB
-rwxr-xr-x
2026-02-10 14:26
selinuxenabled
7.84
KB
-rwxr-xr-x
2026-02-10 14:26
selinuxexeccon
11.86
KB
-rwxr-xr-x
2026-02-10 14:26
semanage
41.18
KB
-rwxr-xr-x
2024-07-02 21:08
semodule
29.27
KB
-rwxr-xr-x
2024-07-02 21:04
sendmail
16.91
KB
-rwxr-sr-x
2026-07-24 13:17
service
3.64
KB
-rwxr-xr-x
2025-09-23 08:27
sestatus
20.41
KB
-rwxr-xr-x
2024-07-02 21:04
setcap
16.27
KB
-rwxr-xr-x
2026-05-04 20:33
setenforce
12.27
KB
-rwxr-xr-x
2026-02-10 14:26
setfiles
20.53
KB
-rwxr-xr-x
2024-07-02 21:04
setpci
28.56
KB
-rwxr-xr-x
2023-03-31 21:30
setquota
91.38
KB
-rwxr-xr-x
2021-10-09 07:08
setroubleshootd
3.34
KB
-rwxr-xr-x
2024-04-06 13:44
setsebool
16.38
KB
-rwxr-xr-x
2024-07-02 21:04
sfdisk
118.51
KB
-rwxr-xr-x
2026-02-04 20:18
showmount
21.06
KB
-rwxr-xr-x
2026-07-08 15:02
shutdown
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
sim_server
11.87
KB
-rwxr-xr-x
2026-05-13 06:34
slattach
43.76
KB
-rwxr-xr-x
2020-08-30 17:47
sm-notify
78.13
KB
-rwxr-xr-x
2026-07-08 15:02
smartctl
907.08
KB
-rwxr-xr-x
2024-04-06 14:11
smartd
733.2
KB
-rwxr-xr-x
2024-04-06 14:11
snmpd
32.45
KB
-rwxr-xr-x
2026-01-19 08:19
snmptrapd
32.6
KB
-rwxr-xr-x
2026-01-19 08:19
sos
627
B
-rwxr-xr-x
2026-08-26 12:50
sos-collector
127
B
-rwxr-xr-x
2026-08-26 12:50
sosreport
117
B
-rwxr-xr-x
2026-08-26 12:50
ss
191.3
KB
-rwxr-xr-x
2024-05-23 08:36
sshd
869.7
KB
-rwxr-xr-x
2026-07-29 12:51
sss_cache
61.09
KB
-rwxr-xr-x
2026-07-28 01:54
sssd
73.01
KB
-rwxr-xr-x
2026-07-28 01:54
start-statd
838
B
-rwxr-xr-x
2018-09-06 18:09
start-stop-daemon
45.98
KB
-rwxr-xr-x
2021-12-15 12:46
suexec
25.3
KB
-rwsr-xr-x
2026-08-11 22:33
sulogin
49.24
KB
-rwxr-xr-x
2026-02-04 20:18
sw-engine-fpm
20.12
MB
-rwxr-xr-x
1990-01-01 12:00
swaplabel
16.5
KB
-rwxr-xr-x
2026-02-04 20:18
swapoff
20.75
KB
-rwxr-xr-x
2026-02-04 20:18
swapon
49.41
KB
-rwxr-xr-x
2026-02-04 20:18
switch_root
16.49
KB
-rwxr-xr-x
2026-02-04 20:18
sysctl
28.88
KB
-rwxr-xr-x
2023-10-14 20:31
syspurpose
415
B
-rwxr-xr-x
2025-07-15 09:13
tcsd
309.72
KB
-rwxr-xr-x
2024-04-06 12:42
telinit
218.45
KB
-rwxr-xr-x
2026-06-16 17:17
testsaslauthd
16.66
KB
-rwxr-xr-x
2022-02-23 20:13
thin_check
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_delta
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_dump
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_ls
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_metadata_pack
907.47
KB
-rwxr-xr-x
2022-10-08 12:29
thin_metadata_size
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_metadata_unpack
895.45
KB
-rwxr-xr-x
2022-10-08 12:29
thin_repair
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_restore
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_rmap
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
thin_trim
1.43
MB
-rwxr-xr-x
2022-10-08 12:29
timedatex
33.43
KB
-rwxr-xr-x
2019-10-16 17:24
tipc
163.07
KB
-rwxr-xr-x
2024-05-23 08:36
tmpwatch
35.47
KB
-rwxr-xr-x
2019-10-12 11:32
tracepath
20.44
KB
-rwxr-xr-x
2023-10-14 17:19
tracepath6
20.44
KB
-rwxr-xr-x
2023-10-14 17:19
tsig-keygen
20.46
KB
-rwxr-xr-x
2026-08-13 18:53
tune2fs
110.63
KB
-rwxr-xr-x
2025-10-07 07:08
tuned
3.88
KB
-rwxr-xr-x
2024-02-22 12:23
tuned-adm
6.5
KB
-rwxr-xr-x
2024-02-22 12:23
udevadm
424.56
KB
-rwxr-xr-x
2026-06-16 17:17
umount.nfs
197.24
KB
-rwsr-xr-x
2026-07-08 15:02
umount.nfs4
197.24
KB
-rwsr-xr-x
2026-07-08 15:02
unbound-anchor
57.34
KB
-rwxr-xr-x
2026-08-17 18:43
unix_chkpwd
36.86
KB
-rwsr-xr-x
2026-08-18 13:12
unix_update
36.86
KB
-rwx------
2026-08-18 13:12
unsquashfs
99.57
KB
-rwxr-xr-x
2024-04-06 14:17
update-alternatives
36.66
KB
-rwxr-xr-x
2023-10-14 22:48
update-pciids
1.71
KB
-rwxr-xr-x
2023-03-31 21:30
update-smart-drivedb
14.44
KB
-rwxr-xr-x
2024-04-06 14:11
useradd
148.16
KB
-rwxr-xr-x
2025-12-18 13:51
userdel
107.29
KB
-rwxr-xr-x
2025-12-18 13:51
usermod
144.11
KB
-rwxr-xr-x
2025-12-18 13:51
usernetctl
12.41
KB
-rwsr-xr-x
2025-11-04 09:19
uuserver
15.88
KB
-rwxr-xr-x
2026-05-13 06:34
vdpa
118.04
KB
-rwxr-xr-x
2024-05-23 08:36
vgcfgbackup
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgcfgrestore
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgchange
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgck
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgconvert
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgcreate
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgdisplay
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgexport
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgextend
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgimport
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgimportclone
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgimportdevices
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgmerge
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgmknodes
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgreduce
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgremove
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgrename
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgs
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgscan
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vgsplit
2.61
MB
-r-xr-xr-x
2026-01-23 07:31
vigr
68.05
KB
-rwxr-xr-x
2025-12-18 13:51
vipw
68.05
KB
-rwxr-xr-x
2025-12-18 13:51
virt-what
14.22
KB
-rwxr-xr-x
2023-10-14 20:52
visudo
239.28
KB
-rwxr-xr-x
2026-04-29 08:49
vmcore-dmesg
28.58
KB
-rwxr-xr-x
2026-02-10 17:24
vpddecode
16.47
KB
-rwxr-xr-x
2024-04-06 13:04
weak-modules
33.6
KB
-rwxr-xr-x
2024-04-08 09:18
whmapi0
3.33
MB
-rwxr-xr-x
2026-08-18 11:03
whmapi1
3.33
MB
-rwxr-xr-x
2026-08-18 11:03
whmlogin
2.33
KB
-rwxr-xr-x
2022-08-21 23:51
wipefs
41.12
KB
-rwxr-xr-x
2026-02-04 20:18
xfs_admin
1.38
KB
-rwxr-xr-x
2023-10-15 05:10
xfs_bmap
695
B
-rwxr-xr-x
2023-10-15 05:11
xfs_copy
434.59
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_db
760.47
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_estimate
12.39
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_freeze
800
B
-rwxr-xr-x
2023-10-15 05:11
xfs_fsr
53.41
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_growfs
422.48
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_info
1.26
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_io
188.28
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_logprint
454.7
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_mdrestore
410.09
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_metadump
782
B
-rwxr-xr-x
2023-10-15 05:10
xfs_mkfile
1.02
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_ncheck
685
B
-rwxr-xr-x
2023-10-15 05:10
xfs_quota
93.98
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_repair
715.24
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_rtcp
16.38
KB
-rwxr-xr-x
2023-10-15 05:11
xfs_spaceman
45.42
KB
-rwxr-xr-x
2023-10-15 05:11
xfsdump
308.02
KB
-rwxr-xr-x
2026-07-29 02:18
xfsinvutil
66.92
KB
-rwxr-xr-x
2026-07-29 02:18
xfsrestore
369.39
KB
-rwxr-xr-x
2026-07-29 02:18
xqmstats
16.45
KB
-rwxr-xr-x
2021-10-09 07:08
xtables-monitor
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
xtables-nft-multi
220.8
KB
-rwxr-xr-x
2024-04-02 18:37
zdump
20.56
KB
-rwxr-xr-x
2026-07-21 14:52
zic
52.83
KB
-rwxr-xr-x
2026-07-21 14:52
zramctl
99.13
KB
-rwxr-xr-x
2026-02-04 20:18
Save
Rename
#!/bin/bash # # Copyright (C) 2021-2023 Red Hat, Inc. All rights reserved. # # This file is part of LVM2. # # This copyrighted material is made available to anyone wishing to use, # modify, copy, or redistribute it subject to the terms and conditions # of the GNU General Public License v.2. # # You should have received a copy of the GNU General Public License # along with this program; if not, write to the Free Software Foundation, # Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA # # Author: Zdenek Kabelac <zkabelac at redhat.com> # # Script for importing VDO volumes to lvm2 managed VDO LVs # # Needed utilities: # lvm, dmsetup, # vdo, # grep, awk, sed, blockdev, readlink, stat, mkdir, truncate # # Conversion is using 'vdo convert' support from VDO manager to move # existing VDO header by 2M which makes space to place in PV header # and VG metadata area, and then create VDOPOOL LV and VDO LV in such VG. # set -euE -o pipefail TOOL=lvm_import_vdo IMPORT_NAME="VDO_${TOOL}_${RANDOM}$$" test ${#IMPORT_NAME} -lt 100 || error "Random name \"$IMPORT_NAME\" is too long!" TEMPDIR="${TMPDIR:-/tmp}/$IMPORT_NAME" _SAVEPATH=$PATH PATH="/sbin:/usr/sbin:/bin:/usr/sbin:$PATH" # Set of trapped signals declare -a SIGNALS=("HUP" "INT" "QUIT" "ABRT" "TERM" "EXIT") # user may override lvm location by setting LVM_BINARY LVM=${LVM_BINARY:-lvm} VDO=${VDO_BINARY:-vdo} BLOCKDEV="blockdev" LOSETUP="losetup" READLINK="readlink" READLINK_E="-e" STAT="stat" MKDIR="mkdir" TRUNCATE="truncate" DMSETUP="dmsetup" DM_DEV_DIR="${DM_DEV_DIR:-/dev}" DM_UUID_PREFIX="${DM_UUID_PREFIX:-}" DM_VG_NAME= DM_LV_NAME= DEFAULT_VDO_CONFIG="/etc/vdoconf.yml" # Default location of vdo's manager config file VDO_CONFIG=${VDO_CONFIG:-} # can be overridden with --vdo-config VDO_CONFIG_RESTORE= VDOCONF= test -n "$VDO_CONFIG" && VDOCONF="-f $VDO_CONFIG" DEVICE= VGNAME= LVNAME= DEVMAJOR=0 DEVMINOR=0 PROMPTING= USE_VDO_DM_SNAPSHOT="--yes" VDO_DM_SNAPSHOT_NAME= VDO_DM_SNAPSHOT_DEVICE= VDO_SNAPSHOT_LOOP= VDO_INCONSISTENT= DRY=0 VERB= FORCE= YES= ABORT_AFTER_VDO_CONVERT=0 VDO_ALLOCATION_PARAMS= # default name for converted VG and its VDO LV DEFAULT_NAME="vdovg/vdolvol" NAME="" # predefine empty vdo_ackThreads= vdo_bioRotationInterval= vdo_bioThreads= vdo_blockMapCacheSize= vdo_blockMapPeriod= vdo_compression= vdo_cpuThreads= vdo_deduplication= vdo_hashZoneThreads= vdo_indexMemory= vdo_indexSparse= vdo_logicalBlockSize= vdo_logicalThreads= vdo_maxDiscardSize= vdo_physicalThreads= vdo_slabSize= vdo_writePolicy= # help message tool_usage() { echo "${TOOL}: Utility to convert VDO volume to VDO LV." echo echo " ${TOOL} [options] <vdo_device_path>" echo echo " Options:" echo " -f | --force Bypass sanity checks" echo " -h | --help Show this help message" echo " -n | --name Specifies VG/LV name for converted VDO volume" echo " -v | --verbose Be verbose" echo " -y | --yes Answer \"yes\" at any prompts" echo " --dry-run Print verbosely commands without running them" echo " --no-snapshot Do not use snapshot for converted VDO device" echo " --uuid-prefix Prefix for DM snapshot uuid" echo " --vdo-config Configuration file for VDO manager" exit } verbose() { test -z "$VERB" || echo "$TOOL:" "$@" } # Support multi-line error messages error() { for i in "$@" ; do echo "$TOOL: $i" >&2 done return 1 } warn() { echo "$TOOL: WARNING: $i" >&2 } dry() { if [ "$DRY" -ne 0 ]; then verbose "Dry execution" "$@" return 0 fi verbose "Executing" "$@" "$@" } cleanup() { RC=$? # Return code + 128 of the last command eg INT=2 + 128 -> 130 trap '' "${SIGNALS[@]}" # mute trap for all signals to not interrupt cleanup() on any next signal [ -z "$PROMPTING" ] || echo "No" [ -e "$VDO_CONFIG_RESTORE" ] && { dry cp -a "$VDO_CONFIG_RESTORE" "${VDO_CONFIG:-"$DEFAULT_VDO_CONFIG"}" || true ; } if [ -n "$VDO_DM_SNAPSHOT_NAME" ]; then dry "$LVM" vgchange -an --devices "$VDO_DM_SNAPSHOT_DEVICE" "$VGNAME" &>/dev/null || true for i in {1..20} ; do [ "$(dry "$DMSETUP" info --noheading -co open "$VDO_DM_SNAPSHOT_NAME")" = "0" ] && break sleep .1 done dry "$DMSETUP" remove "$VDO_DM_SNAPSHOT_NAME" &>/dev/null || true fi [ -n "$VDO_SNAPSHOT_LOOP" ] && { dry "$LOSETUP" -d "$VDO_SNAPSHOT_LOOP" || true ; } [ -z "$VDO_INCONSISTENT" ] || echo "$TOOL: VDO volume import process exited unexpectedly!" >&2 rm -rf "$TEMPDIR" || true exit "$RC" } # Create snapshot target like for persistent snapshot with 16KiB chunksize snapshot_target_line_() { echo "0 $("$BLOCKDEV" --getsize "$1") snapshot${3:-} $1 $2 P 32" } snapshot_create_() { VDO_DM_SNAPSHOT_NAME="${IMPORT_NAME}_snap" local file="$TEMPDIR/$VDO_DM_SNAPSHOT_NAME" # TODO: maybe use ramdisk via 'brd' device ?) "$TRUNCATE" -s 20M "$file" VDO_SNAPSHOT_LOOP=$("$LOSETUP" -f --show "$file") "$DMSETUP" create "$VDO_DM_SNAPSHOT_NAME" -u "${DM_UUID_PREFIX}${VDO_DM_SNAPSHOT_NAME}-priv" --table "$(snapshot_target_line_ "$1" "$VDO_SNAPSHOT_LOOP")" VDO_DM_SNAPSHOT_DEVICE="$DM_DEV_DIR/mapper/$VDO_DM_SNAPSHOT_NAME" verbose "Snapshot of VDO device $1 created: $VDO_DM_SNAPSHOT_DEVICE." } snapshot_merge_() { local status local initial_status initial_status=( $("$DMSETUP" status "$VDO_DM_SNAPSHOT_NAME") ) "$DMSETUP" reload "$VDO_DM_SNAPSHOT_NAME" --table "$(snapshot_target_line_ "$1" "$VDO_SNAPSHOT_LOOP" -merge)" "$DMSETUP" suspend "$VDO_DM_SNAPSHOT_NAME" || { error "ABORTING: Failed to initialize snapshot merge! Origin volume is unchanged." } verbose "Merging converted VDO volume \"$VDO_DM_SNAPSHOT_NAME\"." VDO_INCONSISTENT=1 # Running merging "$DMSETUP" resume "$VDO_DM_SNAPSHOT_NAME" #du -h "$TEMPDIR/$VDO_DM_SNAPSHOT_NAME" # Loop for a while, till the snapshot is merged. # Should be nearly instantaneous. # FIXME: Recovery when something prevents merging is hard for i in $(seq 1 20) ; do status=( $("$DMSETUP" status "$VDO_DM_SNAPSHOT_NAME") ) # Check if merging is finished [ "${status[3]%/*}" = "${status[4]}" ] && break # Wait a bit and retry sleep .2 done if [ "${status[3]%/*}" != "${status[4]}" ]; then # FIXME: Now what shall we do ??? Help.... # Keep snapshot in DM table for possible analysis... VDO_DM_SNAPSHOT_NAME= VDO_SNAPSHOT_LOOP= echo "$TOOL: Initial snapshot status ${initial_status[*]}" echo "$TOOL: Failing merge snapshot status ${status[*]}" error "ABORTING: Snapshot failed to merge! (Administrator required...)" fi VDO_INCONSISTENT= VDO_CONFIG_RESTORE= verbose "Converted VDO volume is merged to \"$1\"." "$DMSETUP" remove "$VDO_DM_SNAPSHOT_NAME" || { sleep 1 # sleep and retry once more "$DMSETUP" remove "$VDO_DM_SNAPSHOT_NAME" || { error "ABORTING: Cannot remove snapshot $VDO_DM_SNAPSHOT_NAME! (check volume autoactivation...)" } } VDO_DM_SNAPSHOT_NAME= "$LOSETUP" -d "$VDO_SNAPSHOT_LOOP" VDO_SNAPSHOT_LOOP= } get_enabled_value_() { case "$1" in enabled) echo "1" ;; *) echo "0" ;; esac } get_kb_size_with_unit_() { case "$1" in *[kK]) echo $(( ${1%[kK]} )) ;; *[mM]) echo $(( ${1%[mM]} * 1024 )) ;; *[gG]) echo $(( ${1%[gG]} * 1024 * 1024 )) ;; *[tT]) echo $(( ${1%[tT]} * 1024 * 1024 * 1024 )) ;; *[pP]) echo $(( ${1%[pP]} * 1024 * 1024 * 1024 * 1024 )) ;; esac } # Figure out largest possible extent size usable for VG # $1 physical size # $2 logical size get_largest_extent_size_() { local max=4 local i local d for i in 8 16 32 64 128 256 512 1024 2048 4096 ; do d=$(( $1 / i )) [ $(( d * i )) -eq "$1" ] || break d=$(( $2 / i )) [ $(( d * i )) -eq "$2" ] || break max=$i done echo "$max" } # detect LV on the given device # deference device name if it is symbolic link detect_lv_() { local DEVICE=$1 local SYSVOLUME local MAJORMINOR DEVICE=${1/#"${DM_DEV_DIR}/"/} DEVICE=$("$READLINK" $READLINK_E "$DM_DEV_DIR/$DEVICE" || true) [ -n "$DEVICE" ] || error "Readlink cannot access device \"$1\"." RDEVICE=$DEVICE case "$RDEVICE" in # hardcoded /dev since udev does not create these entries elsewhere /dev/dm-[0-9]*) read -r <"/sys/block/${RDEVICE#/dev/}/dm/name" SYSVOLUME 2>&1 && DEVICE="$DM_DEV_DIR/mapper/$SYSVOLUME" read -r <"/sys/block/${RDEVICE#/dev/}/dev" MAJORMINOR 2>&1 || error "Cannot get major:minor for \"$DEVICE\"." DEVMAJOR=${MAJORMINOR%%:*} DEVMINOR=${MAJORMINOR##*:} ;; *) RSTAT=$("$STAT" --format "DEVMAJOR=\$((0x%t)) DEVMINOR=\$((0x%T))" "$RDEVICE" || true) [ -n "$RSTAT" ] || error "Cannot get major:minor for \"$DEVICE\"." eval "$RSTAT" ;; esac [ "$DEVMAJOR" != "$(grep device-mapper /proc/devices | cut -f1 -d' ')" ] && return DEV="$("$DMSETUP" info -c -j "$DEVMAJOR" -m "$DEVMINOR" -o uuid,name --noheadings --nameprefixes --separator ' ')" case "$DEV" in Device*) ;; # no devices *) eval "$DEV" ;; esac } # parse yaml config files into 'prefix_yaml_part_names=("value")' strings parse_yaml_() { local yaml_file=$1 local prefix=$2 local s local w local fs s='[[:space:]]*' w='[a-zA-Z0-9_.-]*' fs="$(echo @|tr @ '\034')" ( sed -ne '/^--/s|--||g; s|\"|\\\"|g; s/[[:space:]]*$//g;' \ -e 's/\$/\\\$/g' \ -e "/#.*[\"\']/!s| #.*||g; /^#/s|#.*||g;" \ -e "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \ -e "s|^\($s\)\($w\)${s}[:-]$s\(.*\)$s\$|\1$fs\2$fs\3|p" | awk -F"$fs" '{ indent = length($1)/2; if (length($2) == 0) { conj[indent]="+";} else {conj[indent]="";} vname[indent] = $2; for (i in vname) {if (i > indent) {delete vname[i]}} if (length($3) > 0) { vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")} printf("%s%s%s%s=(\"%s\")\n", "'"$prefix"'",vn, $2, conj[indent-1], $3); } }' | sed -e 's/_=/+=/g' | awk 'BEGIN { FS="="; OFS="=" } /(-|\.).*=/ { gsub("-|\\.", "_", $1) } { print }' ) < "$yaml_file" } # # Convert VDO volume on LV to VDOPool within this VG # # This conversion requires the size of VDO virtual volume has to be expressed in the VG's extent size. # Currently this enforces a user to reduce the VG extent size to the smaller size (up to 4KiB). # # TODO: We may eventually relax this condition just like we are doing rounding for convert_non_lv_() # Let's if there would be any singly user requiring this feature. # It may allow to better use larger VDO volume size (in TiB ranges). # convert_lv_() { local vdo_logicalSize=$1 local extent_size local pvfree pvfree=$("$LVM" lvs -o size --units b --nosuffix --noheadings "$DM_VG_NAME/$DM_LV_NAME") pvfree=$(( pvfree / 1024 )) # to KiB # select largest possible extent size that can exactly express both sizes extent_size=$(get_largest_extent_size_ "$pvfree" "$vdo_logicalSize") # validate existing VG extent_size can express virtual VDO size vg_extent_size=$("$LVM" vgs -o vg_extent_size --units b --nosuffix --noheadings "$VGNAME") vg_extent_size=$(( vg_extent_size / 1024 )) [ "$vg_extent_size" -le "$extent_size" ] || { error "Please vgchange extent_size to at most $extent_size KiB or extend and align virtual size of VDO device on $vg_extent_size KiB before retrying conversion." } verbose "Renaming existing LV to be used as _vdata volume for VDO pool LV." dry "$LVM" lvrename $YES $VERB "$VGNAME/$DM_LV_NAME" "$VGNAME/${LVNAME}_vpool" || { error "Rename of LV \"$VGNAME/$DM_LV_NAME\" failed, while VDO header has been already moved!" } verbose "Converting to VDO pool." dry "$LVM" lvconvert $YES $VERB $FORCE --config "$VDO_ALLOCATION_PARAMS" -Zn -V "${vdo_logicalSize}k" -n "$LVNAME" --type vdo-pool "$VGNAME/${LVNAME}_vpool" verbose "Removing now unused VDO entry from VDO configuration." dry "$VDO" remove $VDOCONF $VERB --force --name "$VDONAME" } # # Convert VDO volume on a device to VG with VDOPool LV # # Convert device with the use of snapshot on top of original VDO volume (can be optionally disabled) # Once the whole conversion is finished, snapshot is merged (During the short period time of merging # user must ensure there will be no power-off!) # # For best use the latest version of vdoprepareforlvm tool is required. convert_non_lv_() { local vdo_logicalSize=$1 local vdo_logicalSizeRounded local extent_size local output local pvfree if [ -n "$USE_VDO_DM_SNAPSHOT" ]; then dry snapshot_create_ "$DEVICE" sed "s|$DEVICE|$VDO_DM_SNAPSHOT_DEVICE|" "$TEMPDIR/vdoconf.yml" > "$TEMPDIR/vdo_snap.yml" # In case of error in the middle of conversion restore original config file VDO_CONFIG_RESTORE="$TEMPDIR/vdoconf.yml" # Let VDO manager operate on snapshot volume dry cp -a "$TEMPDIR/vdo_snap.yml" "${VDO_CONFIG:-"$DEFAULT_VDO_CONFIG"}" else # If error in the following section, report possible problems ahead VDO_INCONSISTENT=1 fi # In case we operate with snapshot, all lvm2 operation will also run on top of snapshot local device=${VDO_DM_SNAPSHOT_DEVICE:-$DEVICE} # Check if there is not already an existing PV header, this would have fail on pvcreate after conversion "$LVM" pvs --devices "$device" "$device" 2>/dev/null && { error "Cannot convert volume \"$DEVICE\" with existing PV header." } verbose "Moving VDO header on \"$device\"." output=$(dry "$VDO" convert $VDOCONF $VERB --force --name "$VDONAME" 2>&1) || { local rc=$? echo "$output" error "Failed to convert VDO volume \"$DEVICE\" (exit code $rc)." } echo "$output" if [ "$ABORT_AFTER_VDO_CONVERT" != "0" ]; then warn "Aborting VDO conversion after moving VDO header, volume is useless!" return 0 fi # Parse result from VDO preparation/conversion tool # New version of the tool provides output with alignment and offset local vdo_length=0 local vdo_aligned=0 local vdo_offset=0 local vdo_non_converted=0 while IFS= read -r line ; do # trim leading spaces case "$(echo $line)" in "Non converted"*) vdo_non_converted=1 ;; "Length"*) vdo_length=${line##* = } ;; "Conversion completed"*) vdo_aligned=${line##*aligned on } vdo_aligned=${vdo_aligned%%[!0-9]*} vdo_offset=${line##*offset } # backward compatibility with report from older version vdo_offset=${vdo_offset##*by } vdo_offset=${vdo_offset%%[!0-9]*} ;; esac done <<< "$output" dry "$LVM" pvcreate $YES $VERB $FORCE --devices "$device" --dataalignment "$vdo_offset"b "$device" # Obtain free space in this new PV # after 'vdo convert' call there is ~(1-2)M free space at the front of the device pvfree=$("$BLOCKDEV" --getsize64 "$DEVICE") pvfree=$(( ( pvfree - vdo_offset ) / 1024 )) # to KiB if [ -n "$vdo_aligned" ] && [ "$vdo_aligned" != "0" ]; then extent_size=$(( vdo_aligned / 1024 )) else extent_size=$(get_largest_extent_size_ "$pvfree" "$vdo_logicalSize") fi # Round virtual size to the LOWER size expressed in extent units. # lvm is parsing VDO metadata and can read real full size and use it instead of this smaller value. # To precisely byte-synchronize the size of VDO LV, user can lvresize such VDO LV later. vdo_logicalSizeRounded=$(( ( vdo_logicalSize / extent_size ) * extent_size )) verbose "Creating volume group \"$VGNAME\" with the extent size $extent_size KiB." dry "$LVM" vgcreate $YES $VERB --devices "$device" -s "${extent_size}k" "$VGNAME" "$device" verbose "Creating VDO pool data LV from all extents in the volume group \"$VGNAME\"." dry "$LVM" lvcreate -Zn -Wn -an $YES $VERB --devices "$device" -l100%VG -n "${LVNAME}_vpool" "$VGNAME" "$device" verbose "Converting to VDO pool." dry "$LVM" lvconvert ${USE_VDO_DM_SNAPSHOT:-"$YES"} $VERB $FORCE --devices "$device" --config "$VDO_ALLOCATION_PARAMS" -Zn -V "${vdo_logicalSizeRounded}k" -n "$LVNAME" --type vdo-pool "$VGNAME/${LVNAME}_vpool" if [ "$vdo_logicalSizeRounded" -lt "$vdo_logicalSize" ]; then # need to extend virtual size to be covering all the converted area # let lvm2 to round to the proper virtual size of VDO LV dry "$LVM" lvextend $YES $VERB --devices "$device" -L "$vdo_logicalSize"k "$VGNAME/$LVNAME" fi VDO_INCONSISTENT= [ -z "$USE_VDO_DM_SNAPSHOT" ] && return # no-snapshot case finished dry "$LVM" vgchange -an $VERB $FORCE --devices "$device" "$VGNAME" # Prevent unwanted auto activation when VG is merged dry "$LVM" vgchange --setautoactivation n $VERB $FORCE --devices "$device" "$VGNAME" if [ -z "$YES" ]; then PROMPTING=yes warn "Do not interrupt merging process once it starts (VDO data may become irrecoverable)!" echo -n "$TOOL: Do you want to merge converted VDO device \"$DEVICE\" to VDO LV \"$VGNAME/$LVNAME\"? [y|N]: " read -r -n 1 -s ANSWER case "${ANSWER:0:1}" in y|Y ) echo "Yes" ;; * ) echo "No" ; PROMPTING=""; return 1 ;; esac PROMPTING="" YES="-y" # From now, now prompting fi dry snapshot_merge_ "$DEVICE" # For systems using devicesfile add 'merged' PV into system.devices. # Bypassing use of --valuesonly to keep compatibility with older lvm. local usedev=$("$LVM" lvmconfig --typeconfig full devices/use_devicesfile || true) [ "${usedev#*=}" = "1" ] && dry "$LVM" lvmdevices --adddev "$DEVICE" # Restore auto activation for a VG dry "$LVM" vgchange --setautoactivation y $VERB $FORCE "$VGNAME" dry "$LVM" lvchange -ay $VERB $FORCE "$VGNAME/$LVNAME" } # Convert existing VDO volume into lvm2 volume convert2lvm_() { local VDONAME local TRVDONAME local FOUND="" local MAJOR=0 local MINOR=0 VGNAME=${NAME%/*} LVNAME=${NAME#*/} DM_UUID="" detect_lv_ "$DEVICE" case "$DM_UUID" in LVM-*) eval "$("$DMSETUP" splitname --nameprefixes --noheadings --separator ' ' "$DM_NAME")" if [ -z "$VGNAME" ] || [ "$VGNAME" = "$LVNAME" ]; then VGNAME=$DM_VG_NAME verbose "Using existing volume group name \"$VGNAME\"." [ -n "$LVNAME" ] || LVNAME=$DM_LV_NAME elif [ "$VGNAME" != "$DM_VG_NAME" ]; then error "Volume group name \"$VGNAME\" does not match name \"$DM_VG_NAME\" for VDO device \"$DEVICE\"." fi ;; *) # Check if we need to generate unused $VGNANE if [ -z "$VGNAME" ] || [ "$VGNAME" = "$LVNAME" ]; then VGNAME=${DEFAULT_NAME%/*} # Find largest matching VG name to our 'default' vgname LASTVGNAME=$(LC_ALL=C "$LVM" vgs -oname -O-name --noheadings -S name=~"${VGNAME}" | grep -m 1 -E "${VGNAME}[0-9]? ?" || true) if [ -n "$LASTVGNAME" ]; then LASTVGNAME=${LASTVGNAME#*"${VGNAME}"} # If the number is becoming too high, try some random number [ -n "$LASTVGNAME" ] && [ "$LASTVGNAME" -gt 99999999 ] && LASTVGNAME=$RANDOM # Generate new unused VG name VGNAME="${VGNAME}$(( LASTVGNAME + 1 ))" verbose "Selected unused volume group name \"$VGNAME\"." fi fi # New VG is created, LV name should be always unused. [ -n "$LVNAME" ] || LVNAME=${DEFAULT_NAME#*/} "$LVM" vgs "$VGNAME" >/dev/null 2>&1 && error "Cannot use already existing volume group name \"$VGNAME\"." ;; esac verbose "Checked whether device \"$DEVICE\" is already logical volume." "$MKDIR" -p -m 0000 "$TEMPDIR" || error "Failed to create \"$TEMPDIR\"." # TODO: might use directly /etc/vdoconf.yml (avoiding need of 'vdo' manager) verbose "Getting YAML VDO configuration." "$VDO" printConfigFile $VDOCONF >"$TEMPDIR/vdoconf.yml" [ -s "$TEMPDIR/vdoconf.yml" ] || error "Cannot work without VDO configuration." # Check list of devices in VDO configure file for their major:minor # and match with given $DEVICE devmajor:devminor for i in $(awk '/.*device:/ {print $2}' "$TEMPDIR/vdoconf.yml") ; do local DEV DEV=$("$READLINK" $READLINK_E "$i") || continue RSTAT=$("$STAT" --format "MAJOR=\$((0x%t)) MINOR=\$((0x%T))" "$DEV" 2>/dev/null) || continue eval "$RSTAT" if [ "$MAJOR" = "$DEVMAJOR" ] && [ "$MINOR" = "$DEVMINOR" ]; then [ -z "$FOUND" ] || error "VDO configuration contains duplicate entries $FOUND and $i." FOUND=$i fi done [ -n "$FOUND" ] || error "Can't find matching device in VDO configuration file." verbose "Found matching device $FOUND $MAJOR:$MINOR." VDONAME=$(awk -v DNAME="$FOUND" '/.*VDOService$/ {VNAME=substr($1, 0, length($1) - 1)} /[[:space:]]*device:/ { if ($2 ~ DNAME) {print VNAME}}' "$TEMPDIR/vdoconf.yml") TRVDONAME=$(echo "$VDONAME" | tr '-' '_') # When VDO volume is 'active', check it's not mounted/being used DM_OPEN="$("$DMSETUP" info -c -o open "$VDONAME" --noheadings --nameprefixes 2>/dev/null || true)" case "$DM_OPEN" in Device*) ;; # no devices *) eval "$DM_OPEN" [ "${DM_OPEN:-0}" -eq 0 ] || error "Cannot convert in use VDO volume \"$VDONAME\"!" ;; esac #parse_yaml_ "$TEMPDIR/vdoconf.yml" _ eval "$(parse_yaml_ "$TEMPDIR/vdoconf.yml" _ | grep "$TRVDONAME" | sed -e "s/_config_vdos_$TRVDONAME/vdo/g")" vdo_logicalSize=$(get_kb_size_with_unit_ "$vdo_logicalSize") vdo_physicalSize=$(get_kb_size_with_unit_ "$vdo_physicalSize") verbose "Converted VDO device has logical/physical size $vdo_logicalSize/$vdo_physicalSize KiB." VDO_ALLOCATION_PARAMS=$(cat <<EOF allocation { vdo_use_compression = $(get_enabled_value_ "$vdo_compression") vdo_use_deduplication = $(get_enabled_value_ "$vdo_deduplication") vdo_use_metadata_hints=1 vdo_minimum_io_size = $vdo_logicalBlockSize vdo_block_map_cache_size_mb = $(( $(get_kb_size_with_unit_ "$vdo_blockMapCacheSize") / 1024 )) vdo_block_map_period = $vdo_blockMapPeriod vdo_use_sparse_index = $(get_enabled_value_ "$vdo_indexSparse") vdo_index_memory_size_mb = $(awk "BEGIN {print $vdo_indexMemory * 1024}") vdo_slab_size_mb = $(( $(get_kb_size_with_unit_ "$vdo_slabSize") / 1024 )) vdo_ack_threads = $vdo_ackThreads vdo_bio_threads = $vdo_bioThreads vdo_bio_rotation = $vdo_bioRotationInterval vdo_cpu_threads = $vdo_cpuThreads vdo_hash_zone_threads = $vdo_hashZoneThreads vdo_logical_threads = $vdo_logicalThreads vdo_physical_threads = $vdo_physicalThreads vdo_write_policy = $vdo_writePolicy vdo_max_discard = $(( $(get_kb_size_with_unit_ "$vdo_maxDiscardSize") / 4 )) vdo_pool_header_size = 0 } EOF ) verbose "VDO conversion parameters: $VDO_ALLOCATION_PARAMS" verbose "Stopping VDO volume." dry "$VDO" stop $VDOCONF --name "$VDONAME" $VERB # If user has not provided '--yes', prompt before conversion if [ -z "$YES" ] && [ -z "$USE_VDO_DM_SNAPSHOT" ]; then PROMPTING=yes echo -n "$TOOL: Convert VDO device \"$DEVICE\" to VDO LV \"$VGNAME/$LVNAME\"? [y|N]: " read -r -n 1 -s ANSWER case "${ANSWER:0:1}" in y|Y ) echo "Yes" ;; * ) echo "No" ; PROMPTING=""; return 1 ;; esac PROMPTING="" YES="-y" # From now, no prompting fi # Make a backup of the existing VDO yaml configuration file [ -e "$VDO_CONFIG" ] && dry cp -a "$VDO_CONFIG" "${VDO_CONFIG}.backup" DEVICE=$FOUND case "$DM_UUID" in LVM-*) convert_lv_ "$vdo_logicalSize" ;; *) convert_non_lv_ "$vdo_logicalSize" ;; esac } ############################# # start point of this script # - parsing parameters ############################# trap "cleanup" "${SIGNALS[@]}" [ "$#" -eq 0 ] && tool_usage while [ "$#" -ne 0 ] do case "$1" in "") ;; "-f"|"--force" ) FORCE="-f" ;; "-h"|"--help" ) tool_usage ;; "-n"|"--name" ) shift; NAME=$1 ;; "-v"|"--verbose") VERB="--verbose" ;; "-y"|"--yes" ) YES="-y" ;; "--abort-after-vdo-convert"|"--abortaftervdoconvert" ) ABORT_AFTER_VDO_CONVERT=1; USE_VDO_DM_SNAPSHOT= ;; # For testing only "--dry-run"|"--dryrun" ) DRY="1" ; VERB="-v" ;; "--no-snapshot"|"--nosnapshot" ) USE_VDO_DM_SNAPSHOT= ;; "--uuid-prefix"|"--uuidprefix" ) shift; DM_UUID_PREFIX=$1 ;; # For testing only "--vdo-config"|"--vdoconfig" ) shift; VDO_CONFIG=$1 ; VDOCONF="-f $VDO_CONFIG" ;; -* ) error "Wrong argument \"$1\". (see: $TOOL --help)" ;; *) DEVICE=$1 ;; # device name does not start with '-' esac shift done [ -n "$DEVICE" ] || error "Device name is not specified. (see: $TOOL --help)" convert2lvm_